Col = {}
local Col_mt = {}

--awesome!
function Col_mt:__call(...)
	local c = {}
	local mt = { __index = self }
	setmetatable(c, mt)
	c:Init(...)
	return c
end

setmetatable(Col, Col_mt)

function Col:Init(r, g, b, a)
	self.rgb = {}
	self.rgb.r = r
	self.rgb.g = g
	self.rgb.b = b
	self.adv = {}
	self.adv.alpha = a or 255
end
function Col:get(n) --returns what is wanted
	if n=="r" or string.lower(n)=="red" then
		return self.rgb.r
	end
	if n=="g" or string.lower(n)=="green" then
		return self.rgb.g
	end
	if n=="b" or string.lower(n)=="blue" then
		return self.rgb.b
	end
	if n=="a" or string.lower(n)=="alpha" then
		return self.adv.alpha
	end
end
function Col:inv() --invert colour
	self.rgb.r = 255-self.rgb.r
	self.rgb.g = 255-self.rgb.g
	self.rgb.b = 255-self.rgb.b
end
function Col:div(n) --divide colour
	self.rgb.r = self.rgb.r/n
	self.rgb.g = self.rgb.g/n
	self.rgb.b = self.rgb.b/n
end
function Col:mult(n) --multiply, limits to 255
	self.rgb.r = math.min(self.rgb.r*n, 255)
	self.rgb.g = math.min(self.rgb.g*n, 255)
	self.rgb.b = math.min(self.rgb.b*n, 255)
end



