
function love.load()
	function makeline(a, b)
		table.insert(lines, {a = a*20, b = b*20})
	end
	function makesurface(a, b , c, d, col)
		local a, b, c, d = a*20, b*20, c*20, d*20
		local mid = (a+b+c+d)/4
		table.insert(surfaces,
			{
				points = {a = a, b = b, c = c, d = d},
				col = col,
				mid = mid,
				norm = cross(a-b, a-c)
			}
		)
	end
	function col(r, g ,b, a)
		return {r = r, g = g, b = b, a = a}
	end

	
	require("Vector3.lua")
	function vlen(v)
		return math.sqrt(v.x*v.x+v.y*v.y+v.z*v.z)
	end
	function vc(b, c)
		return b-c
	end
	function cross(vector1, vector2) 
		return V3.new(vector1.y * vector2.z - vector2.y * vector1.z, vector1.z * vector2.x - vector1.x * vector2.z, vector1.x * vector2.y - vector2.x * vector1.y) 
	end
	function planeintersect(p, n, a1, a2)
		local D = dot(p, n)
		local dir = (a2-a1)
		local denom = -(dot(n, a1)-D)
		local numer = dot(n, dir)
		local t = denom/numer
		local k = 0 --the way it hits the plane
		if denom>0 then k = 1 elseif denom<0 then k =-1 end
		if (t>=0 and t<=1) then
			return a1+V3.new(dir.x*t, dir.y*t, dir.z*t), k
		else
			return nil, k
		end
	end
	function unit(v)
		local len = vlen(v)
		if v.x==0 then vx = 0 else vx = v.x/len end
		if v.y==0 then vy = 0 else vy = v.y/len end
		if v.z==0 then vz = 0 else vz = v.z/len end
		return V3.new(vx, vy, vz)
	end
	controls = {w = false, s = false, a = false, d = false, jump = false, crouch = false, sprint = false}
	player = {
		pos = V3.new(0, 0, 0), --base of player
		height = 10, --height of player
		fat = 4, --area of player
		eye = 9.2, --where the eye is, this is up from
		lookyaw = 0,
		lookpitch = math.pi/2,
		looksensitivity = 1,
		walkspeed = 1,
		sprintspeed = 3,
		crouchspeed = 0.5
	}
	Holdmouse = true
	Started = false
	camera = {
		attachedtoplayer = true,
		Cf = {
			x = 0, y = 0, z = 0, x1 = 1, y1 = 0, z1 = 0, x2 = 0, y2 = 1, z2 = 0, x3 = 0, y3 = 0, z3 = 1
		},
		pos = V3.new(0, 0, 0),
		unit = V3.new(0, 0, 1),
		dimentions = {
			width = 1.2,
			height = 1,
			zoom = 2
		}
	}
	fpsupdate = 0
	fps = 0
	minfps = 1000
	maxfps = 0
end
function Tri(p, d, v0, v1, v2)
	--middle = (v0+v1+v2)/3
	d = V3.new(d.x-p.x, d.y-p.y, d.z-p.z)
	local e1, e2, h, s, q
	local a, f, u, v
	e1 = vc(v1, v0)
	e2 = vc(v2, v0)
	h = cross(d, e2)
	a = dot(e1, h)
	if a>-0.00001 and a<0.00001 then
		return false
	end
	f = 1/a
	s = vc(p, v0)
	u = f*dot(s, h)
	if u<0.0 or u>1.0 then
		return false
	end
	q = cross(s, e1)
	v = f*dot(d, q)
	if v<0.0 or u+v>1.0 then
		return false
	end
	t = f*dot(e2, q)
	if t>0.00001 then
		return true, V3.new(p.x+d.x*t, p.y+d.y*t, p.z+d.z*t), t
	else
		return false
	end
end
function unit(v)
	local len = vlen(v)
	if v.x==0 then vx = 0 else vx = v.x/len end
	if v.y==0 then vy = 0 else vy = v.y/len end
	if v.z==0 then vz = 0 else vz = v.z/len end
	return V3.new(vx, vy, vz)
end
function dot(a, b)
	return (a.x*b.x)+(a.y*b.y)+(a.z*b.z)
end
function getnormals(v)
	local v = unit(v)
	local lv = unit(V3.new(-v.z, 0, v.x))
	local uv = cross(v, lv) 
	return lv, uv
end
function gcp(v, m, left, up, w, h)
	local ld = dot(left, (v-m))
	local ud = dot(up, (v-m))
	if ld<-w then ld = -w end
	if ld>w then ld = w end
	if ud<-h then ud = -h end
	if ud>h then ud = h end
	return m+(left*ld)+(up*ud)
end
function localvec(a, b, norm, right, up)
	local v = V3.new(b.x-a.x, b.y-a.y, b.z-a.z)
	local x = dot(right, v)
	local y = dot(up, v)
	local z = dot(norm, v)
	return V3.new(x, y, z)
end
function printdebug()
	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.print("Holdmouse: "..tostring(Holdmouse), 10, 15, 0, 1, 1)
	love.graphics.print("Fps: "..tostring(math.floor(fps*10)/10), 10, 15*2, 0, 1, 1)
	love.graphics.print("Min Fps: "..tostring(math.floor(minfps*10)/10), 10, 15*3, 0, 1, 1)
	if maxfps>=60 then
		love.graphics.print("Max Fps: "..tostring(math.floor(maxfps*10)/10).. " :D", 10, 15*4, 0, 1, 1)
	else
		love.graphics.print("Max Fps: "..tostring(math.floor(maxfps*10)/10), 10, 15*4, 0, 1, 1)
	end
	--love.graphics.print("Yaw: "..tostring(math.floor(180/math.pi*player.lookyaw)), 10, 15*2, 0, 1, 1)
	--love.graphics.print("Pitch: "..tostring(math.floor(180/math.pi*player.lookpitch)), 10, 15*3, 0, 1, 1)
	--love.graphics.print("x: "..tostring(math.floor(player.pos.x)), 10, 15*4, 0, 1, 1)
	--love.graphics.print("y: "..tostring(math.floor(player.pos.y)), 10, 15*5, 0, 1, 1)
	--love.graphics.print("z: "..tostring(math.floor(player.pos.z)), 10, 15*6, 0, 1, 1)
	love.graphics.print("Controls: movement(a, s, d, w)  Shift+movement = sprint", 10, love.graphics.getHeight()-30, 0, 1, 1)
	love.graphics.print("Mouse = view  Tab = toggle mouse hold  Esc = close", 10, love.graphics.getHeight()-15, 0, 1, 1)
end
function placecam(pos, dir, left, up)
	camera.Cf.x = pos.x
	camera.Cf.y = pos.y
	camera.Cf.z = pos.z
	camera.Cf.x1 = left.x
	camera.Cf.y1 = left.y
	camera.Cf.z1 = left.z
	camera.Cf.x2 = up.x
	camera.Cf.y2 = up.y
	camera.Cf.z2 = up.z
	camera.Cf.x3 = dir.x
	camera.Cf.y3 = dir.y
	camera.Cf.z3 = dir.z
	camera.pos = pos
	camera.unit = dir
end
function get2DPos(pos)
	local cf = camera.Cf
	local off = localvec(V3.new(cf.x, cf.y, cf.z), pos, V3.new(cf.x3, cf.y3, cf.z3), V3.new(cf.x1, cf.y1, cf.z1), V3.new(cf.x2, cf.y2, cf.z2))
	local x = off.x/(off.z/camera.dimentions.zoom)
	local y = off.y/(off.z/camera.dimentions.zoom)
	--if x>screensize.x/2 or x<-screensize.x/2 then x = nil end
	--if y>screensize.y/2 or y<-screensize.y/2 then y = nil end
	return x, y, off.z
end
function adjust(x, y, z)
	local m = math.max(ww, wh)
	return x*m/2+ww, -y*m/2+wh, z
end
function floatText(text, v, size)
	local px, py, pz = get2DPos(v)
	px, py = adjust(px, py)
	if pz>0 and pz<50*size then --check its in front of camera
		love.graphics.print(text, px-(1/(pz/30)*size*text:len()*2.5), py, 0, 1/(pz/30)*size, 1/(pz/30)*size)
	end
end
function drawline(a, b)
	local ax, ay, az = get2DPos(a)
	local bx, by, bz = get2DPos(b)
	if (az>=0 and bz>=0) then --if both points are in front of camera
		local ax, ay = adjust(ax, ay)
		local bx, by = adjust(bx, by)
		if not ((ax<=0 and bx<=0)or(ax>=ww*2 and bx>=ww*2)or(ay<=0 and by<=0)or(ay>=wh*2 and by>=wh*2)) then
			love.graphics.line(ax, ay, bx, by) --easy as that
		end
	end
end
function drawtriangle(a, b ,c)
	local ax, ay, az = get2DPos(a)
	local bx, by, bz = get2DPos(b)
	local cx, cy, cz = get2DPos(c)
	if (az>=0 and bz>=0 and cz>=0) then --if all points are in front of camera
		local ax, ay = adjust(ax, ay)
		local bx, by = adjust(bx, by)
		local cx, cy = adjust(cx, cy)
		
		if not ((ax<=0 and bx<=0 and cx<=0)or(ax>=ww*2 and bx>=ww*2 and cx>=ww*2)or(ay<=0 and by<=0 and cy<=0)or(ay>=wh*2 and by>=wh*2 and cy>=wh*2)) then
			love.graphics.triangle("fill", ax, ay, bx, by, cx, cy) --easy as that
		end
	end
end
function doline(a, b)
	local po, k = planeintersect(camera.pos+V3.new(camera.unit.x/50, camera.unit.y/50, camera.unit.z/50), camera.unit, a, b) -- it was a pain in the @$$ so i had to do this to fix it
	if po then po.x, po.y, po.z = math.floor(po.x*10000000)/10000000, math.floor(po.y*10000000)/10000000, math.floor(po.z*10000000)/10000000 end
	--if po then print(po.x, po.y, po.z) end
	if po~= nil then
		if k==-1 then
			--drawline(b, po)
			drawline(a, po)
		elseif k == 1 then
			--drawline(a, po)
			drawline(b, po)
		else
			drawline(a, po)
		end
	else
		drawline(a, b) --draw as normal
	end
end
function dotriangle(a, b ,c) --holy fuck this is complicated
	local camplane = camera.pos+V3.new(camera.unit.x/50, camera.unit.y/50, camera.unit.z/50)
	local c1, k1 = planeintersect(camplane, camera.unit, a, b)
	if c1 then c1.x, c1.y, c1.z = math.floor(c1.x*10000000)/10000000, math.floor(c1.y*10000000)/10000000, math.floor(c1.z*10000000)/10000000 end
	local c2, k2 = planeintersect(camplane, camera.unit, a, c)
	if c2 then c2.x, c2.y, c2.z = math.floor(c2.x*10000000)/10000000, math.floor(c2.y*10000000)/10000000, math.floor(c2.z*10000000)/10000000 end
	local c3, k3 = planeintersect(camplane, camera.unit, b, c)
	if c3 then c3.x, c3.y, c3.z = math.floor(c3.x*10000000)/10000000, math.floor(c3.y*10000000)/10000000, math.floor(c3.z*10000000)/10000000 end
	if c1 and c2 then
		--if k1==-1 and k2==-1 then
			drawtriangle(a, c1 ,c2)
		--elseif k1==1 and k2==1 then
			drawtriangle(c ,c1, b)
			drawtriangle(c, c1, c2)
		--end
	end
		if c2 and c3 then
		--if k2==1 and k3==1 then
			drawtriangle(c, c2 ,c3)
		--elseif k2==-1 and k3==-1 then
			drawtriangle(a, b ,c3)
			drawtriangle(a, c2 ,c3)
		--end
	end
	if c1 and c3 then
		--if k1==1 and k3==-1 then
			drawtriangle(b, c1 ,c3)
		--elseif k1==-1 and k3==1 then
			drawtriangle(a, c ,c3)
			drawtriangle(c1, a ,c3)
		--end
	end
	if c1==nil and c2==nil and c3==nil then --simple
		drawtriangle(a, b ,c)
	end
end



function dorect(a, b, c, d)
	local camplane = camera.pos+V3.new(camera.unit.x/50, camera.unit.y/50, camera.unit.z/50)
	local c1, k1 = planeintersect(camplane, camera.unit, a, b)
	
	
	
	
	
	
end
function drawsurface(s) --glitchy, gonna take a while to fix =/
	--print(error("Attempted to execute function 'drawsurface', Function not finished!", 2))
	--------------------------------------------------------------------------------------------------------DRAWSURFACE
end
table.dupe = function(t)
	if type(t) == "table" then
		local new = {}
		for i, v in pairs(t) do
			local nn = table.dupe(v)
			if type(v) == "table" then
				meta = getmetatable(v)
				setmetatable(nn, meta)
			end
			new[i] = nn -- dupes any tables that pass through
		end
		return new
	else
		return t --if its not a table, it just returns the argument given
	end
end
function surfacesort(a, b) --------------------------------------------------------------------------------sorts surfaces
	if a~= nil and b~= nil then
		local ma = (a.mid-camera.pos)*1
		local mb = (b.mid-camera.pos)*1
		local da = math.floor(V3.dot(camera.unit, ma)*10000)/10000
		local db = math.floor(V3.dot(camera.unit, mb)*10000)/10000
		return da>db
	end
	return 1<2 --WORKS OMG WOW! NOT SLOW EITHER!
end
function love.draw()
	local gr = love.graphics
	gr.setLineWidth(2)
	ww = gr.getWidth()/2
	wh = gr.getHeight()/2
	gr.setBackgroundColor(255, 255, 255)
	gr.setColor(0, 0, 0, 255)
	gr.setPointSize(4)
	floatText("0", V3.new(0, 0, 0), 4)
	floatText("Z", V3.new(0, 0, 30), 4)
	floatText("X", V3.new(30, 0, 0), 4)
	floatText("Y", V3.new(0, 30, 3), 4)
	--Set Color: gr.setColor(0, 0, 0, 255)
	--Draw Line: drawline( V3.new(0, 0, 0), V3.new(0, 0, 0) )
	--Axis Guide:
	gr.setColor(255, 0, 0, 255)
	doline( V3.new(0, 0, 0), V3.new(100000, 0, 0) )
	gr.setColor(0, 255, 0, 255)
	doline( V3.new(0, 0, 0), V3.new(0, 0, 100000) )
	gr.setColor(0, 0, 255, 255)
	doline( V3.new(0, 0, 0), V3.new(0, 100000, 0) )
	gr.setColor(0, 0, 0, 255)
	

	--------------------------------------------------------------------------------------------------------DRAW HERE
	
	
	
	
		--[[ show cursor ]]--
	gr.setPointSize(2)
	gr.setColor(0, 0, 0, 255)
	gr.point(ww, wh)
	gr.point(ww-10, wh)
	gr.point(ww+10, wh)
	gr.point(ww, wh+10)
	gr.point(ww, wh-10)
	printdebug()
end
function love.update(dt)
	if Holdmouse then
		if controls.w and not controls.s then
			if controls.sprint == true then
				player.pos.x = player.pos.x+math.sin(player.lookyaw)*math.sin(player.lookpitch)*player.sprintspeed
				player.pos.y = player.pos.y+math.cos(player.lookpitch)*player.sprintspeed
				player.pos.z = player.pos.z+math.cos(player.lookyaw)*math.sin(player.lookpitch)*player.sprintspeed
			else
				if controls.crouch then
					player.pos.x = player.pos.x+math.sin(player.lookyaw)*math.sin(player.lookpitch)*player.crouchspeed
					player.pos.y = player.pos.y+math.cos(player.lookpitch)*player.crouchspeed
					player.pos.z = player.pos.z+math.cos(player.lookyaw)*math.sin(player.lookpitch)*player.crouchspeed
				else
					player.pos.x = player.pos.x+math.sin(player.lookyaw)*math.sin(player.lookpitch)*player.walkspeed
					player.pos.y = player.pos.y+math.cos(player.lookpitch)*player.walkspeed
					player.pos.z = player.pos.z+math.cos(player.lookyaw)*math.sin(player.lookpitch)*player.walkspeed
				end
			end
		end
		if controls.s and not controls.w then
			if controls.sprint == true then
				player.pos.x = player.pos.x-math.sin(player.lookyaw)*math.sin(player.lookpitch)*player.sprintspeed
				player.pos.y = player.pos.y-math.cos(player.lookpitch)*player.sprintspeed
				player.pos.z = player.pos.z-math.cos(player.lookyaw)*math.sin(player.lookpitch)*player.sprintspeed
			else
				if controls.crouch then
					player.pos.x = player.pos.x-math.sin(player.lookyaw)*math.sin(player.lookpitch)*player.crouchspeed
					player.pos.y = player.pos.y-math.cos(player.lookpitch)*player.crouchspeed
					player.pos.z = player.pos.z-math.cos(player.lookyaw)*math.sin(player.lookpitch)*player.crouchspeed
				else
					player.pos.x = player.pos.x-math.sin(player.lookyaw)*math.sin(player.lookpitch)*player.walkspeed
					player.pos.y = player.pos.y-math.cos(player.lookpitch)*player.walkspeed
					player.pos.z = player.pos.z-math.cos(player.lookyaw)*math.sin(player.lookpitch)*player.walkspeed
				end
			end
		end
		if controls.a and not controls.d then
			if controls.sprint == true then
				player.pos.x = player.pos.x-math.sin(player.lookyaw+math.pi/2)*player.sprintspeed
				--player.pos.y = player.pos.y
				player.pos.z = player.pos.z-math.cos(player.lookyaw+math.pi/2)*player.sprintspeed
			else
				if controls.crouch then
					player.pos.x = player.pos.x-math.sin(player.lookyaw+math.pi/2)*player.crouchspeed
					--player.pos.y = player.pos.y
					player.pos.z = player.pos.z-math.cos(player.lookyaw+math.pi/2)*player.crouchspeed
				else
					player.pos.x = player.pos.x-math.sin(player.lookyaw+math.pi/2)*player.walkspeed
					--player.pos.y = player.pos.y
					player.pos.z = player.pos.z-math.cos(player.lookyaw+math.pi/2)*player.walkspeed
				end
			end
		end
		if controls.d and not controls.a then
			if controls.sprint == true then
				player.pos.x = player.pos.x+math.sin(player.lookyaw+math.pi/2)*player.sprintspeed
				--player.pos.y = player.pos.y
				player.pos.z = player.pos.z+math.cos(player.lookyaw+math.pi/2)*player.sprintspeed
			else
				if controls.crouch then
					player.pos.x = player.pos.x+math.sin(player.lookyaw+math.pi/2)*player.crouchspeed
					--player.pos.y = player.pos.y
					player.pos.z = player.pos.z+math.cos(player.lookyaw+math.pi/2)*player.crouchspeed
				else
					player.pos.x = player.pos.x+math.sin(player.lookyaw+math.pi/2)*player.walkspeed
					--player.pos.y = player.pos.y
					player.pos.z = player.pos.z+math.cos(player.lookyaw+math.pi/2)*player.walkspeed
				end
			end
		end
	end
	if Started then
		love.mouse.setGrab(Holdmouse)
		love.mouse.setVisible(not Holdmouse)
		if Holdmouse then
			local x, y = love.mouse.getPosition()
			local xdrag = x-ScreenWidth/2
			local ydrag = y-ScreenHeight/2
			local xch = xdrag*dt/5*player.looksensitivity
			local ych = ydrag*dt/5*player.looksensitivity
			player.lookyaw = player.lookyaw+xch
			if player.lookyaw>math.pi*2 then player.lookyaw = player.lookyaw-math.pi*2 end
			if player.lookyaw<0 then player.lookyaw = player.lookyaw+math.pi*2 end
			player.lookpitch = math.max(math.min(math.pi*0.99, player.lookpitch+ych), math.pi-math.pi*0.99)
			
			love.mouse.setPosition(ScreenWidth/2,ScreenHeight/2)
		end
	else
		love.mouse.setPosition(ScreenWidth/2,ScreenHeight/2)
		Pw = ScreenWidth/2
		Ph = ScreenHeight/2
		Started = true
	end
	camdir = V3.new(math.sin(player.lookyaw)*math.sin(player.lookpitch), math.cos(player.lookpitch), math.cos(player.lookyaw)*math.sin(player.lookpitch))
	camright = V3.new(math.sin(player.lookyaw+math.pi/2), 0, math.cos(player.lookyaw+math.pi/2))
	placecam(V3.new(player.pos.x, player.pos.y+player.eye, player.pos.z), camdir, camright, cross(camdir, camright))
		--now to build everything around the camera:
	--renderlist = {}
	--createstack()
	if Started then --my own version of getFPS()
		if fpsupdate>10 then
			fpsupdate = 0
			fps = 1/dt
		else
			fpsupdate = fpsupdate+1
		end
		if fps~=0 then
			if fps>maxfps then maxfps = fps end
			if fps<minfps then minfps = fps end
		end
	end
end
function love.mousepressed( x, y, button)
	if button == "l" then
		
	end
end
function love.mousereleased( x, y, button )
	if button == "l" then
	end
end
b = function() print(string.char(7)) end
function love.keypressed(key)
	if key == "tab" then
		Holdmouse = not Holdmouse
	end
	if key == "w" then --create new shape
		controls[key] = true
	end
	if key == "a" then --create new shape
		controls[key] = true
	end
	if key == "s" then --create new shape
		controls[key] = true
	end
	if key == "d" then --create new shape
		controls[key] = true
	end
	if key == "lshift" then
		controls.sprint = true
	end
	if key == "lctrl" then
		controls.crouch = true
	end
	if key == "escape" then
		love.event.push("q")
	end
	--if key == "b" then
	--	b()
	--end
end
function love.keyreleased(key)
	if key == "w" then --create new shape
		controls[key] = false
	end
	if key == "a" then --create new shape
		controls[key] = false
	end
	if key == "s" then --create new shape
		controls[key] = false
	end
	if key == "d" then --create new shape
		controls[key] = false
	end
	if key == "lshift" then
		controls.sprint = false
	end
	if key == "lctrl" then
		controls.crouch = false
	end
end
--600 lines :D