print("	Loading Vector3.lua")
Vector3 = {}
Vector3.mt = {}
function Vector3.new(_x, _y, _z)
	local set = {x = _x or 0, y = _y or 0, z = _z or 0}
	setmetatable(set, Vector3.mt)
	return set
end
function Vector3.mt._tostring(v)
	return "{".. v.x .. "," .. v.y .. "," .. v.z .. "}"
end
function Vector3.mt.__add(a,b)
	local res = Vector3.new{}
	if getmetatable(a)~=Vector3.mt then
		return error("Error: Cannot Add "..type(a).." And Vector3", 2)
		--for k in pairs(a) do res[k] = b[k]+a end
	elseif getmetatable(b)~=Vector3.mt then
		return error("Error: Cannot Add Vector3 And "..type(b), 2)
		--for k in pairs(a) do res[k] = a[k]+b end
	else
		res.x = a.x+b.x
		res.y = a.y+b.y
		res.z = a.z+b.z
	end
	return res
end
function Vector3.mt.__sub(a,b)
	local res = Vector3.new{}
	if getmetatable(a)~=Vector3.mt then
		return error("Error: Cannot Add "..type(a).." And Vector3", 2)
		--for k in pairs(a) do res[k] = b[k]+a end
	elseif getmetatable(b)~=Vector3.mt then
		return error("Error: Cannot Add Vector3 And "..type(b), 2)
		--for k in pairs(a) do res[k] = a[k]+b end
	else
		res.x = a.x-b.x
		res.y = a.y-b.y
		res.z = a.z-b.z
	end
	return res
end

function Vector3.mt.__concat(a)
	return ("[".. a.x ..",".. a.y ..",".. a.z .."]")
end
function Vector3.mt.__tostring(a)
	return ("[".. a.x ..",".. a.y ..",".. a.z .."]")
end
function Vector3.mt.__unm(a) --minus
	return Vector3.new(-a.x, -a.y, -a.z)
end

function Vector3.mt.__mul(a,b)
	local res = Vector3.new{}
	if getmetatable(a)~=Vector3.mt then
		res.x = b.x*a
		res.y = b.y*a
		res.z = b.z*a
	elseif getmetatable(b)~=Vector3.mt then
		res.x = a.x*b
		res.y = a.y*b
		res.z = a.z*b
	else
		res.x = a.x*b.x
		res.y = a.y*b.y
		res.z = a.z*b.z
	end
	return res
end

function Vector3.mt.__div(a,b)
	local res = Vector3.new{}
	if getmetatable(a)~=Vector3.mt then
		return error("Error: Cannot Divide "..type(a).." By Vector3", 2)
	elseif getmetatable(b)~=Vector3.mt then
		res.x = a.x/b
		res.y = a.y/b
		res.z = a.z/b
	else
		res.x = a.x*b.x
		res.y = a.y*b.y
		res.z = a.z*b.z
	end
	return res
end

function Vector3.cross(vector1, vector2) 
		return Vector3.new(vector1.y * vector2.z - vector2.y * vector1.z, vector1.z * vector2.x - vector1.x * vector2.z, vector1.x * vector2.y - vector2.x * vector1.y) 
	end
	function Vector3.dot(a, b)
	return (a.x*b.x + a.y*b.y + a.z*b.z)
end

function Vector3.distance(a, b)
	local dx = a.x-b.x
	local dy = a.y-b.y
	local dz = a.z-b.z
	local d = math.sqrt(dx*dx+dy*dy+dz*dz)
	return d
end

--The following work with ZFrame only:
function Vector3.toLocal(zf, a)
	local b = a-zf.p
	local dx = zf.DX
	local dy = zf.DY
	local dz = zf.DZ
	return Vector3.new(
		Vector3.dot(zf.dx, b),
		Vector3.dot(zf.dy, b),
		Vector3.dot(zf.dz, b)
	)
end
function Vector3.toWorld(zf, a)
	return zf.p+a.x*zf.DX+a.y*zf.DY+a.z*zf.DZ --pos plus local vector along euler axis'
end