
function love.load()
	require("bin/lib/Vector2.lua")
	require("bin/lib/Vector3.lua")
	require("bin/lib/Math.lua")
	Lbuffer = love.graphics.newFramebuffer(500, 500)
	Rbuffer = love.graphics.newFramebuffer(500, 500)
	objects = {}
	for i = 1, 20 do
		local newpos = Vector3.new(math.random(-130,130),math.random(-130,130),math.random(-130,130))
		local newvel = Vector3.cross(newpos, Vector3.new(math.random(-10, 10)/3,math.random(-10, 10)/3,math.random(-10, 10)/3) )
		local newcol = Vector3.new(math.random(1, 255),math.random(1, 255),math.random(1, 255))
		local newsize = math.random(5, 18)
		new(newpos, newvel, newcol, newsize)
	end
end
function new(pos, vel, col, size)
	local ob = {}
	ob.pos = pos
	ob.vel = vel
	ob.col = col
	ob.size = size
	table.insert(objects, ob)
end
function updatescene() --create the scene
	local scene = {}
	temptable = {}
	local Cent = V2.new(0,0)
	for i, v in pairs(objects) do
		local dir = getdir(Cent, v.pos+v.vel/2)
		v.vel.x = v.vel.x-v.pos.x/2
		v.vel.y = v.vel.y-v.pos.y/2
		v.vel.z = v.vel.z-v.pos.z/2
		
		v.pos.x = v.pos.x+v.vel.x/100
		v.pos.y = v.pos.y+v.vel.y/100
		v.pos.z = v.pos.z+v.vel.z/100
		temptable[i] = v
	end
	table.sort(temptable, function(a, b) if a.pos.z<b.pos.z then return true else return false end end) --sort the scene objects so they draw in order
	table.insert(scene, temptable)
	return scene
end
function drawscene(sc, xm, ym)
	gr = love.graphics
	ents = sc[1]
	gr.push()
	gr.translate(250, 250)
	for i, v in pairs(ents) do
		gr.setColor(v.col.x, v.col.y, v.col.z, 255)
		local xp = v.pos.x
		local yp = v.pos.y
		local zp = v.pos.z
		local size = v.size
		xpos = xp+xp*(zp/200)+zp*xm/200
		ypos = yp+yp*(zp/200)+zp*ym/200
		rad = size+size*(zp/200)
		gr.circle("fill", xpos, ypos, rad, 20)
		gr.setColor(0,0,0,255)
		gr.circle("line", xpos, ypos, rad, 20)
	end
	--for i, v in pairs(ents) do
	--	for j, w in pairs(ents) do
	--		if i~=j and j>i then
	--			if Vector3.distance(v.pos, w.pos) <=(v.size+w.size) then
	--				local a = v.vel
	--				local b = w.vel
	--				
	--				
	--				v.vel = -b
	--				w.vel = -a
	--
	--			end
	--		end
	--	end
	--end
	gr.pop()
end
function love.draw()
	sce = updatescene()
	local gr = love.graphics
	local ww = gr.getWidth()
	local wh = gr.getHeight()
	gr.setBackgroundColor(0, 0, 0)
	gr.setColor(255, 255, 255, 255)
	gr.setRenderTarget(Lbuffer)
	gr.setColor(255, 255, 255, 255)
	gr.rectangle("fill", 0,0,500,500) --background
	drawscene(sce,-20,0)
	
	gr.setRenderTarget(Rbuffer)
	gr.setColor(255, 255, 255, 255)
	gr.rectangle("fill", 0,0,500,500) --background
	drawscene(sce,20, 0)
	
	gr.setRenderTarget()
	gr.setColor(255, 255, 255, 255)
	gr.draw(Lbuffer, 0,0,0,1,1)
	gr.draw(Rbuffer, 500, 0, 0, 1, 1)
	gr.setColor(0, 0, 0, 255)
	gr.line(500, 0, 500, 500)
	gr.print("cross your eyes", 30, 20, 0, 1.5, 1.5)
	gr.print("cross your eyes", 530, 20, 0, 1.5, 1.5)
	gr.print("cross your eyes", 33, 50, 0, 1.1, 1.1)
	gr.print("cross your eyes", 527, 50, 0, 1.1, 1.1)
end
function love.mousepressed( x, y, button)
	if button == "l" then
		
	end
end
function love.mousereleased( x, y, button )
	if button == "l" then
		
	end
end
function love.keypressed(key)
	if key == "w" then
		
	end
end
function love.keyreleased(key)
	if key == "w" then
		
	end
end
