
function love.load()
	require("Vector2.lua")
	points = {a=V2.new(100, 100), b=V2.new(100, 300),c= V2.new(300, 300), d=V2.new(300, 100)}
	selrad = 7
	selected = 0
	lol = 0.5
	showlol = false
end
function bezier(t, p0, p1, p2, p3)
	B=( ( ( 1 - t ) ^ 3 ) * p0 )
	+ ( 3 * ( ( 1 - t ) ^ 2 ) * t * p1 )
	+ ( 3 * ( 1 - t ) * (t^2) * p2 )
	+ ( (t^3) * p3)
	return B
end
function love.draw()
	local gr = love.graphics
	local ww = gr.getWidth()/2
	local wh = gr.getHeight()/2
	gr.setBackgroundColor(255, 255, 255)
	local mo = V2.new(love.mouse.getPosition())
	gr.setLineWidth(1)
	for i, v in pairs(points) do
		if i == selected then
			v.x = mo.x --place point
			v.y = mo.y --place point
			gr.setColor(255, 0, 0, 255/3)
			gr.circle("fill", v.x, v.y, selrad, 20)
			gr.setColor(255, 0, 0, 255)
			gr.circle("line", v.x, v.y, selrad, 20)
		elseif getdist(v, mo)<selrad then
			gr.setColor(0, 255/1.5, 0, 255/3)
			gr.circle("fill", v.x, v.y, selrad, 20)
			gr.setColor(0, 255/1.5, 0, 255)
			gr.circle("line", v.x, v.y, selrad, 20)
		else
			gr.setColor(0, 0, 255, 255/3)
			gr.circle("fill", v.x, v.y, selrad, 20)
			gr.setColor(0, 0, 255, 255)
			gr.circle("line", v.x, v.y, selrad, 20)
		end
	end
	--dots last:
	gr.setColor(0, 0, 0, 255)
	gr.setPointSize(5)
	for i, v in pairs(points) do
		gr.point(v.x, v.y)
	end
	gr.setColor(0, 0, 0, 255/3)
	gr.line(points.a.x, points.a.y, points.b.x, points.b.y)
	gr.line(points.b.x, points.b.y, points.c.x, points.c.y)
	gr.line(points.c.x, points.c.y, points.d.x, points.d.y)
	
	gr.setColor(0, 0, 0, 255)
	gr.setLineWidth(2)
	reso = 50
	st = 1/reso
	for t = 0, 1, st do
		a = bezier(t, points.a, points.b, points.c, points.d)
		b = bezier(t+st, points.a, points.b, points.c, points.d)
		gr.line(a.x, a.y, b.x, b.y)
	end
	if showlol then
		gr.setLineWidth(2)
		gr.setColor(0, 255/1.5, 0, 255/2)
		lawl = cosinewave(lol)
		p1 = getpoint(lawl, points.a ,points.b)
		p2 = getpoint(lawl, points.b ,points.c)
		p3 = getpoint(lawl, points.c ,points.d)
		gr.point(p1.x, p1.y)
		gr.point(p2.x, p2.y)
		gr.point(p3.x, p3.y)
		gr.line(p1.x, p1.y, p2.x, p2.y)
		gr.line(p2.x, p2.y, p3.x, p3.y)
		p4 = getpoint(lawl, p1 ,p2)
		p5 = getpoint(lawl, p2 ,p3)
		gr.point(p4.x, p4.y)
		gr.point(p5.x, p5.y)
		gr.line(p4.x, p4.y, p5.x, p5.y)
		p6 = getpoint(lawl, p4 ,p5)
		gr.point(p6.x, p6.y)
		dir = getdir(p4, p5)+math.pi/2
		p7 = p6-sincos(dir)*10
		p8 = p6+sincos(dir)*10
		gr.setLineWidth(1)
		gr.setColor(0, 0, 0, 255)
		gr.line(p7.x, p7.y, p8.x, p8.y)
	end
end
function love.update(dt)
	if love.keyboard.isDown("up") then
		lol = math.min(lol+dt/3, 1)
	end
	if love.keyboard.isDown("down") then
		lol = math.max(lol-dt/3, 0)
	end
end
function love.mousepressed( x, y, button)
	if button == "l" then
		local mo = V2.new(x, y)
		for i, v in pairs(points) do
			if getdist(v, mo)<selrad then
				selected = i
			end
		end
	end
end
function love.mousereleased( x, y, button )
	if button == "l" then
		local mo = V2.new(x, y)
		
		selected = 0
	end
end
function love.keypressed(key)
	if key == " " then
		showlol = not showlol
	end
end