
function love.load()
	deb = false
	lines = {}
	times = 50
	Circles = {}
	Circles[1] = {x = 250, y = 250, r = 70}
	Circles[2] = {x = 150, y = 150, r = 40}
	for i = 1, times do
		local line = {
		center = V2.new(250+math.sin(math.pi*2/times*i)*70, 250+math.cos(math.pi*2/times*i)*70),
		a = nil,
		b = nil,
		norm = nil,
		CircleID = 2
		}
		line.a = V2.new(line.center.x+math.sin(math.pi*2/times*i+math.pi/2)*(math.pi*70/times), line.center.y+math.cos(math.pi*2/times*i+math.pi/2)*(math.pi*70/times))
		line.b = V2.new(line.center.x+math.sin(math.pi*2/times*i+math.pi/2)*-(math.pi*70/times), line.center.y+math.cos(math.pi*2/times*i+math.pi/2)*-(math.pi*70/times))
		line.norm = V2.new(-math.sin(math.pi*2/times*i), -math.cos(math.pi*2/times*i))
		table.insert(lines, line)
	end
	for i = 1, times do
		local line = {
		center = V2.new(150+math.sin(math.pi*2/times*i)*40, 150+math.cos(math.pi*2/times*i)*40),
		a = nil,
		b = nil,
		norm = nil,
		CircleID = 1
		}
		line.a = V2.new(line.center.x+math.sin(math.pi*2/times*i+math.pi/2)*(math.pi*70/times), line.center.y+math.cos(math.pi*2/times*i+math.pi/2)*(math.pi*70/times))
		line.b = V2.new(line.center.x+math.sin(math.pi*2/times*i+math.pi/2)*-(math.pi*70/times), line.center.y+math.cos(math.pi*2/times*i+math.pi/2)*-(math.pi*70/times))
		line.norm = V2.new(-math.sin(math.pi*2/times*i), -math.cos(math.pi*2/times*i))
		table.insert(lines, line)
	end
end
V2 = {}
function V2.new(Xx, Yy)
	if Xx==nil then
		return {x = 0, y = 0}
	elseif Xx~=nil and Yy==nil then
		return {x = Xx, y = 0} --nil
	elseif Xx~=nil and Yy~=nil then
		return {x = Xx, y = Yy}
	end
end

function getdir(a, b)
	x = b.x-a.x
	y = b.y-a.y
	dx = x
	dy = y
	d = math.atan2(dy, dx)-math.pi/2
	return -d
end
function getdist(a, b)
	dx = a.x-b.x
	dy = a.y-b.y
	d = math.sqrt(dx*dx+dy*dy)
	return d
end
function dot(a, b)
	return (a.x*b.x + a.y*b.y)
end


function lum(lightdir, norm)
	local d = dot(norm, lightdir)
	if d>0 then
		dist = getdist(V2.new(0, 0), lightdir)
		return 1/dist*d
	else
		return 0
	end
end
function love.draw()
	local gr = love.graphics
	local ww = gr.getWidth()
	local wh = gr.getHeight()
	if deb then
		gr.setBackgroundColor(255/10, 255/10, 255/10)
	else
		gr.setBackgroundColor(255, 255, 255)
	end
	gr.setColor(255, 255/1.25, 0, 255)
	viewcount = 0
	gr.circle("fill", love.mouse.getX(), love.mouse.getY(), 4, 10)
	strength = 50
	gr.setLineWidth(1.6)
	for i, v in pairs(lines) do
		ld = V2.new(v.center.x - love.mouse.getX(), v.center.y - love.mouse.getY())
		l = lum(ld, v.norm)
		fa = getdist(V2.new(), ld)
		di = getdir(V2.new(), ld)+math.pi
		Circle = Circles[v.CircleID]
		--linePoint1, lineDirection, lineLength, sphereCenter, radius
		local a,b = V2.collidewithball(v.center, di, fa, Circle, Circle.r)
		--if deb then
		--	gr.setColor(0, 0, 0, 255/3)
		--	gr.line(v.center.x, v.center.y, v.center.x+v.norm.x*l*30, v.center.y+v.norm.y*l*30)
		--end
		l = math.max(-0.1, math.min(1, l*(1/((fa)/strength))))
		if deb then
			if a~=nil then
				gr.setColor(0, 0, 0, 255)
			else
				gr.setColor(l*255, l*255/1.25, 0, 255)
			end
		else
			if a~=nil then
				gr.setColor(255, 255/1.25, 0, 0)
			else
				gr.setColor(255, 255/1.25, 0, l*255)
			end
		end
		gr.setLineWidth(2)
		gr.line(v.a.x, v.a.y, v.b.x, v.b.y)
		if l>0 then
			viewcount = viewcount+1
			--if deb then
			--	gr.setLineWidth(0.1)
			--	gr.setColor(0, 0, 0, 255/10)
			--	gr.line(v.center.x, v.center.y, love.mouse.getX(), love.mouse.getY())
			--end
		else
			if deb then
				gr.setColor(0, 0, 0, 255)
				gr.setLineWidth(2)
				gr.line(v.a.x, v.a.y, v.b.x, v.b.y)
			else
				gr.setColor(255, 255/1.25, 0, 0)
			end
		end
	end
	if deb then
		gr.setColor(255, 255, 0, 255)
	else
		gr.setColor(0, 0, 0, 255)
	end
	gr.print("Visible Planes: " ..viewcount, 15, 15, 0, 1, 1)
	gr.print("Mouse Left = Toggle Debug/Light", 15, wh-15, 0, 1, 1)
end
function love.mousepressed( x, y, button)
	if button == "l" then
		deb = not deb
	end
end
function V2.getvector(dir, len)
	return V2.new(math.sin(dir)*len, math.cos(dir)*len)
end
function V2.getLineSphereCollide(linePoint1, lineDirection, lineLength, sphereCenter, radius)
	local lineVector = V2.getvector(lineDirection, lineLength)
	local a = lineVector.x * lineVector.x + lineVector.y * lineVector.y
	local b = lineVector.x * (linePoint1.x - sphereCenter.x) + lineVector.y * (linePoint1.y - sphereCenter.y)
	local c = (linePoint1.x - sphereCenter.x) * (linePoint1.x - sphereCenter.x) + (linePoint1.y - sphereCenter.y) * (linePoint1.y - sphereCenter.y) - radius * radius
	if (a > 0) and (b * b >= a * c) then
		local diff = math.sqrt(b * b - a * c)
		return ((-b - diff) / a), ((diff - b) / a)
	else
		return -1, -1
	end
end
function V2.collidewithball(st, dir, len, cen, rad)
	time, max = V2.getLineSphereCollide(st, dir, len, cen, rad)
	if (time < 1) and (time > 0) then
		vector = V2.getvector(dir, len)
		pos = V2.new(math.floor(time*vector.x+st.x+0.5), math.floor(time*vector.y+st.y+0.5))
		return pos, time
	else
		return nil, 0
	end
end