V2 = {}
V2.mt = {}
function V2.new(xx, yy)
	local set = {x = xx, y = yy}
	setmetatable(set, V2.mt)
	return set
end
function V2.print (s)
	print(V2.tostring(s))
end
function V2.mt.__add(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		return error("Error: Cannot Add "..type(a).." And V2", 2)
		--for k in pairs(a) do res[k] = b[k]+a end
	elseif getmetatable(b)~=V2.mt then
		return error("Error: Cannot Add V2 And "..type(b), 2)
		--for k in pairs(a) do res[k] = a[k]+b end
	else
		for k in pairs(a) do res[k] = a[k]+b[k] end
	end
	return res
end
function V2.mt.__mul(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		for k in pairs(b) do res[k] = b[k]*a end
	elseif getmetatable(b)~=V2.mt then
		for k in pairs(a) do res[k] = a[k]*b end
	else
		for k in pairs(a) do res[k] = a[k]*b[k] end
	end
	return res
end
function V2.mt.__sub(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		--return error("Error: Cannot Subject "..type(a).." And V2", 2)
		for k in pairs(b) do res[k] = b[k]+a end
	elseif getmetatable(b)~=V2.mt then
		--return error("Error: Cannot Subtract V2 And "..type(b), 2)
		for k in pairs(a) do res[k] = a[k]+b end
	else
		for k in pairs(a) do res[k] = a[k]-b[k] end
	end
	return res
end
function V2.mt.__div(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		for k in pairs(a) do res[k] = b[k]/a end
	elseif getmetatable(b)~=V2.mt then
		for k in pairs(a) do res[k] = a[k]/b end
	else
		for k in pairs(a) do res[k] = a[k]/b[k] end
	end
	return res
end
function V2.mt.__pow(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		for k in pairs(a) do res[k] = b[k]^a end
	elseif getmetatable(b)~=V2.mt then
		for k in pairs(a) do res[k] = a[k]^b end
	else
		for k in pairs(a) do res[k] = a[k]^b[k] end
	end
	return res
end
print("V2 Object Loaded!")


function getdir(a, b)
	x = b.x-a.x
	y = b.y-a.y
	dx = x
	dy = y
	d = math.atan2(dy, dx)-math.pi/2
	return -d
end
function getdist(a, b)
	dx = a.x-b.x
	dy = a.y-b.y
	d = math.sqrt(dx*dx+dy*dy)
	return d
end
function dot(a, b)
	return (a.x*b.x + a.y*b.y)
end

function cross(a, b, c, d)
	local denom =	((d.y - c.y)*(b.x - a.x))-((d.x - c.x)*(b.y - a.y))
	local numa  =	((d.x - c.x)*(a.y - c.y))-((d.y - c.y)*(a.x - c.x))
	local numb  =	((b.x - a.x)*(a.y - c.y))-((b.y - a.y)*(a.x - c.x))
	if denom == 0 then
		if numa == 0 and numb == 0 then
			return false, nil
		end
		return false, nil
	end
	local ua = numa/denom
	local ub = numb/denom
	if (ua >= 0.0 and ua <= 1.0 and ub >= 0.0 and ub <= 1.0) then
		local x = a.x + ua*(b.x - a.x);
		local y = a.y + ua*(b.y - a.y);
		return true, V2.new(x, y)
	end
	return false, nil
end


function sincos(ang)
	return V2.new(math.sin(ang), math.cos(ang))
end

function dot(a, b)
	return (a.x*b.x + a.y*b.y)
end
function getpoint(t, a ,b)
	if not (t>=0 and t<=1) then return error("Error in function 'getpoint': t must be between 0 and 1") end
	local diff = (b-a)
	local new = a+diff*t
	return new
end
