
function love.load()
	math.randomseed(os.time())
	require("bin/lib/Vector2.lua")
	function randomget(it)
		return math.random(-10,10)/10*(1.5^-it)
	end
	function frac(grid, rem, it)
		--grid: fractal grid
		--rem: iterations remaining
		ngrid = {}
		for y = 1, #grid-1 do
			realrow = {}
			newrow = {}
			for x = 1, #grid[y]-1 do
				a = grid[y][x]
				b = grid[y+1][x]
				c = grid[y][x+1]
				d = grid[y+1][x+1]
				e = (a+b+c+d)/4+randomget(it)
				table.insert(realrow, grid[y][x])
				table.insert(realrow, "a")
				table.insert(newrow, "a")
				table.insert(newrow, e)
				if x==#grid[y]-1 then --last iteration
					table.insert(realrow, grid[y][x+1])
					table.insert(newrow, "a")
				end
			end
			table.insert(ngrid, realrow)
			table.insert(ngrid, newrow)
			if y==#grid-1 then
				local realrow = {}
				for x = 1, #grid[y]-1 do
					table.insert(realrow, grid[y][x])
					table.insert(realrow, "a")
					if x==#grid[y]-1 then --last iteration
						table.insert(realrow, grid[y][x+1])
					end
				end
				table.insert(ngrid, realrow)
			end
		end
		for y, v in pairs(ngrid) do
			for x, h in pairs(v) do
				if h=="a" then
					total = 0
					div = 0
					if x-1>0 then
						total = total+ngrid[y][x-1]
						div = div+1
					end
					if x+1<=#v then
						total = total+ngrid[y][x+1]
						div = div+1
					end
					if y-1>0 then
						total = total+ngrid[y-1][x]
						div = div+1
					end
					if y+1<=#grid then
						total = total+ngrid[y+1][x]
						div = div+1
					end
					avg = total/div+randomget(it)
					ngrid[y][x] = avg --replace
				end
			end
		end
		rem = rem-1
		it = it+1
		if rem>0 then
			return frac(ngrid, rem, it)
		end
		return ngrid
	end
	function smooth(grid)
		local ng = {}
		for y, v in pairs(grid) do
			ng[y] = {}
			for x, h in pairs(v) do
				total = h
				div = 1
				if x-1>0 then
					total = total+ngrid[y][x-1]
					div = div+1
				end
				if x+1<=#v then
					total = total+ngrid[y][x+1]
					div = div+1
				end
				if y-1>0 then
					total = total+ngrid[y-1][x]
					div = div+1
				end
				if y+1<=#grid then
					total = total+ngrid[y+1][x]
					div = div+1
				end
				if x-1>0 and y-1>0 then
					total = total+ngrid[y-1][x-1]
					div = div+1
				end
				if x-1>0 and y+1<#grid then
					total = total+ngrid[y+1][x-1]
					div = div+1
				end
				if x+1<#v and y+1<#grid then
					total = total+ngrid[y+1][x+1]
					div = div+1
				end
				if x+1<#v and y-1>0 then
					total = total+ngrid[y-1][x+1]
					div = div+1
				end
				
				avg = total/div
				ng[y][x] = avg
			end
		end
		return ng
	end
	grid = frac({
	{0,0,0},
	{0,0,0},
	{0,0,0}}, 8, 1)
	minval = 0
	maxval = 0
	for y, v in pairs(grid) do
		for x, h in pairs(v) do
			if h>maxval then maxval = h end
			if h<minval then minval = h end
		end
	end
	print("min: "..minval)
	print("max: "..maxval)
	for y, v in pairs(grid) do
		for x, h in pairs(v) do
			grid[y][x] = grid[y][x]+((y-#grid/2)/(#grid/2))*0
		end
	end
	grid = smooth(grid)
	waittime = 20
	waited = 0
end

function love.draw()
	local gr = love.graphics
	local ww = gr.getWidth()
	local wh = gr.getHeight()
	gr.setBackgroundColor(255, 255, 255)
	gr.setColor(0, 0, 0, 255)
	xs = ww/#grid[1]
	ys = wh/#grid
	for y, v in pairs(grid) do
		yp = y*ys-ys
		for x, h in pairs(v) do
			xp = x*xs-xs
			colval = (255/2+255/2*h)
				--math.floor(math.max(0, math.min(colval, 255))/10)*10
			gr.setColor(0,0,0,colval)
			if h then
				gr.rectangle("fill",xp, yp, xs, ys)
			end
		end
	end
end
function love.update(dt)
	waited = waited+dt
	if waited>=waittime then
		love.load()
	end
end
function love.mousepressed( x, y, button)
	if button == "l" then
		
	end
end
function love.mousereleased( x, y, button )
	if button == "l" then
		
	end
end
function love.keypressed(key)
	if key == "w" then
		
	end
end
function love.keyreleased(key)
	if key == "w" then
		
	end
end
