
function love.load()
	require("Vector2.lua")
	screensize = 700
	iterations = 9
	rot = 60
end

function love.draw()
	local gr = love.graphics
	local ww = gr.getWidth()
	local wh = gr.getHeight()
	gr.setBackgroundColor(255, 255, 255)
	gr.setColor(0, 0, 0, 255)
	gr.setPointSize(2, 2)
	div = 2
	len = screensize/2
	start = V2.new(ww/2-math.sin(math.rad(180-rot))*len, wh/1.9-math.cos(math.rad(180-rot))*len)
	ennd = V2.new(ww/2-math.sin(math.rad(180+rot))*len, wh/1.9-math.cos(math.rad(180+rot))*len)
	dat = {{a = start, b = ennd,len = getdist(start, ennd), t = 1, ang = math.pi/2}}
	--gr.point(start.x, start.y)
	gr.setLineWidth(0.5)
	for i = 1, iterations do
		newdat = {}
		for n, v in pairs(dat) do
			a = v.a
			b = v.b
			len = v.len
			t = v.t
			nlen = len/2
			ang = v.ang
			ang1 = ang+math.rad(rot)*t
			ang2 = ang1-math.rad(rot)*t
			ang3 = ang2-math.rad(rot)*t
			t1 = -t
			t2 = t
			t3 = -t
			p1 = a+sincos(ang1)*nlen
			p2 = p1+sincos(ang2)*nlen
			table.insert(newdat, {a = a, b = p1, len = nlen, t = t1, ang = ang1})
			table.insert(newdat, {a = p1, b = p2, len = nlen, t = t2, ang = ang2})
			table.insert(newdat, {a = p2, b = b, len = nlen, t = t3, ang = ang3})
		end
		dat = newdat
	end
	for i, v in pairs(dat) do
		a = v.a
		b = v.b
		len = v.len
		gr.line(a.x, a.y, b.x, b.y)
		gr.point(a.x, a.y)
		gr.point(b.x, b.y)
		
	end
end
function love.mousepressed( x, y, button)
	if button == "l" then
		
	end
end
function love.mousereleased( x, y, button )
	if button == "l" then
		
	end
end
function love.keypressed(key)
	if key == "w" then
		
	end
end
function love.keyreleased(key)
	if key == "w" then
		
	end
end
