
function love.load()
	require("Vector2.lua")
	ispaused = true
	ismakingline = false
	iserasingline = false
	allowtoggle = true
	bodies = {}
	shapes = {}
	ballrad = 5
	Ballstart = {x = ballrad*6, y = ballrad*3}
	world = love.physics.newWorld(-love.graphics.getWidth(),-love.graphics.getHeight(),love.graphics.getWidth()*2,love.graphics.getHeight()*2)
	world:setGravity(0,30*ballrad)
	bodnum = 0
	bodies.ball = love.physics.newBody(world, Ballstart.x, Ballstart.y, 1, 0.01)
	shapes.ball = love.physics.newCircleShape(bodies.ball, 0, 0, ballrad )
	shapes.ball:setFriction(1)
	shapes.ball:setRestitution(0.5)
	mo_st = V2.new(love.mouse.getX(), love.mouse.getY()) --mouse start
	floorlines = {}
	bodnum = bodnum+1
	ballglow = 0
	trail = {}
	for i = 1, 25 do
		table.insert(trail, V2.new(Ballstart.x, Ballstart.y))
	end
	traildt = 0
	trailstep = 0.01
	minlinelength = 5
	timespeed = 1
	mintime = 0
	maxtime = 5
	timechange = 0.2
end

function cross(a, b, c, d)
	local denom =	((d.y - c.y)*(b.x - a.x))-((d.x - c.x)*(b.y - a.y))
	local numa  =	((d.x - c.x)*(a.y - c.y))-((d.y - c.y)*(a.x - c.x))
	local numb  =	((b.x - a.x)*(a.y - c.y))-((b.y - a.y)*(a.x - c.x))
	if denom == 0 then
		if numa == 0 and numb == 0 then
			return false, nil
		end
		return false, nil
	end
	local ua = numa/denom
	local ub = numb/denom
	if (ua >= 0.0 and ua <= 1.0 and ub >= 0.0 and ub <= 1.0) then
		local x = a.x + ua*(b.x - a.x);
		local y = a.y + ua*(b.y - a.y);
		return true, V2.new(x, y)
	end
	return false, nil
end


function love.draw()
	local gr = love.graphics
	local ww = gr.getWidth()
	local wh = gr.getHeight()
	gr.setBackgroundColor(255, 255, 255)
	gr.setColor(255, 0, 0, 255)
	gr.setLineWidth(2)
	local mx = love.mouse.getX()
	local my = love.mouse.getY()
	x1, y1, x2, y2, x3, y3, x4, y4 = shapes.ball:getBoundingBox()
	BR = shapes.ball:getRadius()
	Bx = bodies.ball:getX()
	By = bodies.ball:getY()
	gr.setColor(255, 0, 255/1.5, 255/10)
	gr.setLineWidth(ballrad/2)
	for i, v in pairs(trail) do
		gr.circle("fill", v.x, v.y, BR, 20)
		if i<#trail then
			gr.line(v.x, v.y, trail[i+1].x, trail[i+1].y)
		end
	end
	gr.setLineWidth(2)
	gr.circle("line", Bx+math.sin(ballglow)*2, By+math.cos(ballglow)*2, BR*1.2, 15)
	gr.circle("line", Bx+math.sin(ballglow*1.3+math.pi/2)*3, By+math.cos(ballglow*1.3+math.pi/2)*3, BR*1.6, 25)
	gr.circle("line", Bx+math.sin(ballglow*1.8+math.pi/3)*5, By+math.cos(ballglow*1.8+math.pi/3)*5, BR*1.9, 25)
	gr.setColor(255, 0, 0, 255)
	gr.circle("fill", Bx, By, BR, 20)
	gr.setColor(255, 255, 255, 255)
	Ba = -bodies.ball:getAngle()
	gr.line(Bx-math.sin(Ba)*BR, By-math.cos(Ba)*BR, Bx+math.sin(Ba)*BR, By+math.cos(Ba)*BR)
	--if Bx-BR>ww then bodies.ball:setX(0-BR) end
	--if Bx+BR<0 then bodies.ball:setX(ww+BR) end
	--if By-BR>wh then bodies.ball:setY(0-BR) end
	--if By+BR<0 then bodies.ball:setY(wh+BR) end
	bodies.ball:setX(Bx%ww)
	bodies.ball:setY(By%wh)
	gr.setColor(0, 0, 0, 255/4)
	gr.print("Space to reset", 15, 15*1, 0, 1, 1)
	gr.print("Click and drag left mouse to create line", 15, 15*2, 0, 1, 1)
	gr.print("Click and drag right mouse to erase lines", 15, 15*3, 0, 1, 1)
	gr.print("Up/Down arrows to change speed", 15, 15*4, 0, 1, 1)
	gr.setColor(0, 0, 0, 255)
	gr.setLineWidth(1)
	for i, v in pairs(floorlines) do
		a = v.a
		b = v.b
		gr.line(a.x, a.y, b.x, b.y)
	end
	if ismakingline or iserasingline then --because i like it this way :P
		local mox = love.mouse.getX()
		local moy = love.mouse.getY()
		dist = math.sqrt((mox-mo_st.x)*(mox-mo_st.x)+(moy-mo_st.y)*(moy-mo_st.y))
		if dist>=minlinelength then
			if ismakingline and not iserasingline then
				gr.setColor(0, 255, 0, 255)
			elseif iserasingline and not ismakingline then
				gr.setColor(0, 0, 255, 255)
			end
		else
			gr.setColor(255, 0, 0, 255)
		end
		gr.setPointSize(4)
		gr.setLineWidth(2)
		gr.point(mo_st.x, mo_st.y)
		gr.line(mo_st.x, mo_st.y, mox, moy)
		gr.point(mox, moy)
	end
	gr.setColor(0, 0, 0, 255)
	gr.line(mx, 0, mx, 40)
	gr.line(mx, wh, mx, wh-40)
	gr.line(0, my, 40, my)
	gr.line(ww, my, ww-40, my)
	gr.print("Speed: "..timespeed, 15, wh-15, 0, 1, 1)
end
function getnorm(v)
	local x = v.x
	local y = v.y
	local d = math.sqrt(x*x+y*y)
	xx = x/d
	yy = y/d
	return V2.new(yy, -xx), V2.new(x/2, y/2), d
end
function love.update(dt)
	if ispaused == false then
		world:update(0.01*timespeed)
		ballglow = ballglow+math.pi*dt/2
		if ballglow>=math.pi*100 then ballglow = ballglow-math.pi*100 end
		if traildt+dt>=trailstep then
			old = trail[1]
			old.x = bodies.ball:getX()
			old.y = bodies.ball:getY()
			table.remove(trail, 1) --remove first element
			table.insert(trail, old)
			traildt = traildt-trailstep
		else
			traildt = traildt+dt
		end
	end
end
function love.mousepressed( x, y, button)
	if button == "l" then
		mo_st.x = love.mouse.getX()
		mo_st.y = love.mouse.getY()
		ismakingline = true
	elseif button == "r" then
		mo_st.x = love.mouse.getX()
		mo_st.y = love.mouse.getY()
		iserasingline = true
	end
end
function love.mousereleased( x, y, button )
	if button == "l" then
		ismakingline = false
		local mx = love.mouse.getX()
		local my = love.mouse.getY()
		--make line to collide with
		mid = V2.new(mo_st.x+(mx-mo_st.x)/2, mo_st.y+(my-mo_st.y)/2)
		--table.insert(floorlines, {a = {x = mo_st.x, y = mo_st.y}, b = {x = mx, y = my}})
		local n, p, d = getnorm(V2.new(mx - mo_st.x, my - mo_st.y))
		if d>=minlinelength then
			a = V2.new(mid.x+p.x, mid.y+p.y)
			b = V2.new(mo_st.x, mo_st.y)
			table.insert(floorlines, {a = V2.new(a.x, a.y), b = V2.new(b.x, b.y), link = bodnum+0})
			bodies[bodnum] = love.physics.newBody(world, p.x, p.y, 0, 0)--static
			shapes[bodnum] = love.physics.newPolygonShape(bodies[bodnum], a.x-n.x*1.3-p.x, a.y-n.y*1.3-p.y, a.x+n.x*1.3-p.x, a.y+n.y*1.3-p.y, b.x+n.x*1.3-p.x, b.y+n.y*1.3-p.y, b.x-n.x*1.3-p.x, b.y-n.y*1.3-p.y)
			shapes[bodnum]:setFriction(1)
			shapes[bodnum]:setRestitution(0.5)
			bodnum = bodnum+1
		end
	elseif button == "r" then
		iserasingline = false
		local mx = love.mouse.getX()
		local my = love.mouse.getY()
		local lines_to_remove = {}
		for i, v in pairs(floorlines) do
			hit, p = cross(mo_st, V2.new(mx, my), v.a, v.b)
			if hit then
				table.insert(lines_to_remove, i)
			end
		end
		if #lines_to_remove>0 then
			for i = #lines_to_remove, 1, -1 do --work backwards, easier
				shapenum = floorlines[ lines_to_remove[i] ].link
				bodies[shapenum]:destroy( )
				bodies[shapenum] = nil
				shapes[shapenum]:destroy( )
				shapes[shapenum] = nil
				table.remove(floorlines, lines_to_remove[i])
			end
		end
	end
end
function love.keypressed(key)
	if key == " " then 
		if allowtoggle == true then --can only be executed if space has been lifted
			if ispaused == true then ispaused = false else ispaused = true bodies.ball:setPosition(Ballstart.x, Ballstart.y) bodies.ball:setLinearVelocity(0, 0) bodies.ball:setAngularVelocity(0) bodies.ball:setAngle(0) end
			allowtoggle = false
		end
	end
	if key == "up" then
		timespeed = math.min(maxtime, math.max(mintime, timespeed+0.2))
	end
	if key == "down" then
		timespeed = math.min(maxtime, math.max(mintime, timespeed-0.2))
	end
end
function love.keyreleased(key)
	if key == " " then --create new shape
		allowtoggle = true --pause/play
	end
end
